#include <iostream>
#include "Conjunto.h"

/*****************************************************
	Contructores
 *****************************************************/

Conjunto::Conjunto()
{
}

Conjunto::Conjunto(int elemento)
{
	elementos.push_back(elemento);

}

/*****************************************************
	Operaciones
 *****************************************************/

void Conjunto::Display()											//Muestra el conjunto por pantalla
{
	cout<<'{';
	for(int i=0;i<elementos.size();i++)
	{
		if(i==0)
			cout<<elementos[i];
		else
			cout<<','<<elementos[i];
	}
	cout<<'}'<<endl;
}

void Conjunto::AgregarElemento(int elemento)						//Agrega un elemento no repetido al conjunto
{
	for(int i=0;i<elementos.size();i++)
		if(elementos[i]==elemento)
			return;
	elementos.push_back(elemento);

}

Conjunto Conjunto::operator +(const Conjunto & conjunto)			//Sobrecargo del operador suma, para permitir  union
{
	Conjunto resultado;
	for(int i=0;i<elementos.size();i++)
		resultado.AgregarElemento(elementos[i]);
	for(int i=0;i<conjunto.elementos.size();i++)
		resultado.AgregarElemento(conjunto.elementos[i]);
	return resultado;

}

Conjunto Conjunto::operator *(const Conjunto & conjunto)			//Sobrecargo del operador *, para permitir interseccion
{
	Conjunto resultado;
	for(int i=0;i<elementos.size();i++)
		for(int j=0;j<conjunto.elementos.size();j++)
			if(elementos[i]==conjunto.elementos[j])
				resultado.AgregarElemento(elementos[i]);
	return resultado;
				
}

int Conjunto::operator ==(const Conjunto & conjunto)				//Sobrecargo del operador ==, para permitir igualdad
{
	int contador=0;
	if(elementos.size() != conjunto.elementos.size())
		return 0;
	for(int i=0;i<elementos.size();i++)
		for(int j=0;j<conjunto.elementos.size();j++)
			if(elementos[i] == conjunto.elementos[j])
				contador++;
	if (contador==elementos.size())
		 return 1;
	 else
		 return 0;

}

void Conjunto::Limpiar()											//Vacia el conjunto
{
	int max_elem = elementos.size();
	for(int i=0;i<max_elem;i++)
		elementos.pop_back();
}


