#include <iostream>
#include "Processor.h"
#include "unexpectedValue.h"
#include "Conjunto.h"


Processor::Processor(string s, Conjunto c[], char d[][100])					//Constructor
{
	str=s;
	pos=0;
	for(int i=0;i<100;i++)
		conjuntos[i]=c[i];
	for(int i=0;i<100;i++)
		for(int j=0;j<100;j++)
			datos[i][j]=d[i][j];

}
Conjunto Processor::retorno()												//Devolucoin del conjunto respuesta
{
	return E();
}

int Processor::eval()														//Display del conjunto respuesta
{ 
  try {
      E().Display();
	  return 0;
  }catch( UnexpectedValue & e) {
    cerr << "Error: \n";
    cerr << str << '\n';
    for (int i=0 ; i < pos; i++) cerr << ' ';
    cerr << "^\n";
    cerr << "Se esperaba "<<e.getmsg()<< endl;
    return 0;
  }
}

Conjunto Processor::E()														//Operaciones caracteristicas del metodo recursivo
{
  try {
    Conjunto t = T();
    return Ep(t);
  } catch(UnexpectedValue &e) {
    throw e;
  }
}

Conjunto Processor::Ep(Conjunto tl)											//Operaciones caracteristicas del metodo recursivo
{
  Conjunto tr;
  char op;
  try {
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    op=str[pos];
    if (op!='+'/* && op!='-'*/) return tl;
    pos++;
    tr = T();
    switch(op) {
    case '+': return(Ep(tl+tr));
//    case '-': return(Ep(tl-tr));
    }
  } catch(UnexpectedValue &e) {
    throw e;
  }
}

Conjunto Processor::T()														//Operaciones caracteristicas del metodo recursivo
{
  try {
    Conjunto f = F();
    return (Tp(f));
  }catch(UnexpectedValue &e){
    throw e;
  }
}

Conjunto Processor::Tp(Conjunto fl)											//Operaciones caracteristicas del metodo recursivo
{
  Conjunto fr;
  char op;

  try {
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    op=str[pos];
    if (op!='*') return fl;
    pos++;
    fr = F();
    switch(op) {
    case '*': return(Tp(fl*fr));
    }  
  }catch(UnexpectedValue &e) {
    throw e;
  }
}

Conjunto Processor::F()														//Operaciones caracteristicas del metodo recursivo
{
  char op;
  Conjunto result;

  while(str[pos]==' ') pos++;  // saltamos espacios en blanco
  op=str[pos];
  if (op == '(') {
    pos++;
    result= E();
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    if (str[pos]==')' ) {
      pos++;
      return result;
	}
    else throw UnexpectedValue(" )" ,pos);
  }
  else {
    char digit;
    Conjunto conjunto;
    while(str[pos]==' ') pos++;  // saltamos espacios en blanco
    if ((str[pos]<'A') || ('Z' < str[pos]))									
      throw UnexpectedValue("un Conjunto",pos);
	while (('A'<=str[pos]) &&(str[pos]<='Z'))								//Se identifican las letras de los conjuntos
	{
		for(int i=0;i<100;i++)
			if(str[pos]==datos[i][0])										//Se determina a que conjunto corresponde
				conjunto=conjuntos[i];			
		pos++;
    return conjunto;														//Uso del conjunto que se debe utilizar
    }
  }
}


